﻿Imports System.Xml
Imports System.Xml.Schema
Imports System.Xml.Serialization
Imports System.Text


Public Class frmAdmin

    ''' <summary>
    ''' Class for Admin information 
    ''' </summary>
    Public Class AdminInformation
        Public Class PortInfo
            Public PortName As String
            Public Selected As Boolean
        End Class

        Public FirmwarePath As String = GetConfigureInfoPath() + "\Firmware\"
        Public ProgrammerPath As String = "C:\Program Files (x86)\melabs Programmer\meProg.exe"
        Public ComPorts() As PortInfo
        Public AtmelICE() As String
        Public Sub Load()
            Dim filename As String = GetConfigureInfoPath() + "\NCDConfig.cfg"
            If IO.File.Exists(filename) Then
                Dim x As XmlSerializer = New XmlSerializer(GetType(AdminInformation))
                Dim sw As System.IO.StreamReader = New System.IO.StreamReader(filename)
                Dim d As AdminInformation = x.Deserialize(sw)
                FirmwarePath = d.FirmwarePath
                ProgrammerPath = d.ProgrammerPath
                ComPorts = d.ComPorts
                AtmelICE = d.AtmelICE
                sw.Close()
            End If

        End Sub

        Public Sub Save()
            Dim w As XmlWriter = XmlWriter.Create(GetConfigureInfoPath() + "\NCDConfig.cfg")
            Dim x As New XmlSerializer(GetType(AdminInformation))
            x.Serialize(w, Me)
            w.Close()
        End Sub

        ''' <summary>
        ''' Update serial ports scaned, will keep selected ports's status if they are exist
        ''' </summary>
        Public Sub UpdateSerialPorts(ports() As PortInfo)
            If ports Is Nothing Then
                Exit Sub
            End If
            If ComPorts Is Nothing Then
                ComPorts = ports
                Exit Sub
            End If
            For Each newPort As PortInfo In ports
                For Each oldPort As PortInfo In ComPorts
                    If (newPort.PortName = oldPort.PortName) Then
                        newPort.Selected = oldPort.Selected
                    End If
                Next
            Next
            ' update ports
            ComPorts = ports
        End Sub

        ''' <summary>
        ''' Get unselected ports, will return in a string list
        ''' </summary>
        ''' <returns></returns>
        Public Function GetUnselectedPorts(allPorts() As String) As String()
            If allPorts Is Nothing Then
                Exit Function
            End If
            If ComPorts Is Nothing Then
                Return allPorts
            End If
            Dim unselectedPorts As New ArrayList
            For Each p In allPorts
                For Each cp In ComPorts
                    If p = cp.PortName And Not cp.Selected Then
                        unselectedPorts.Add(p)
                    End If
                Next
            Next
            Return unselectedPorts.ToArray(GetType(String))
        End Function


        Public Function GetConfigureInfoPath() As String
            GetConfigureInfoPath = System.Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\NCDAdmin"
            IO.Directory.CreateDirectory(GetConfigureInfoPath)
        End Function
    End Class

    Public adminInfo As New AdminInformation

    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public FormLoading As Boolean = True

    Dim FirmwarePath As String = "C:\Users\NCDAdmin\Documents\Firmware\"
    Dim ProgrammerPath As String = "C:\Program Files (x86)\melabs Programmer\meProg.exe"
    Dim AtmelICE() As String = {"1800090522", "18000089357", "18000089453"}

    Public Sub CPUError()
        MsgBox("CPU and Firmware Not Yet Defined")
    End Sub
    Private Sub RunConfigure(config As String)

        Dim strExe As String = ProgrammerPath
        Dim p As New Process
        Dim pinfo As New ProcessStartInfo
        Dim Prog As String = " -A64"
        Dim Burn As Boolean = False

        Dim CPUIDFlag As Boolean = False
        For Temp As Integer = 1 To Len(config)
            If Temp > 10 And CPUIDFlag = False Then
                If Mid(config, Temp, 1) = "-" Then
                    If Mid(config, Temp + 1, 1) = "D" Then
                        CPU.Text = Mid(config, Temp + 2, Len(config))
                        CPUIDFlag = True
                    End If
                End If
            End If
        Next

        For Programmer As Integer = 1 To 56
            Burn = False
            If Programmer = 1 And Programmer1.Checked = True Then Burn = True : Prog = " -A64"
            If Programmer = 2 And Programmer2.Checked = True Then Burn = True : Prog = " -A65"
            If Programmer = 3 And Programmer3.Checked = True Then Burn = True : Prog = " -A66"
            If Programmer = 4 And Programmer4.Checked = True Then Burn = True : Prog = " -A67"
            If Programmer = 5 And Programmer5.Checked = True Then Burn = True : Prog = " -A68"
            If Programmer = 6 And Programmer6.Checked = True Then Burn = True : Prog = " -A69"
            If Programmer = 7 And Programmer7.Checked = True Then Burn = True : Prog = " -A70"
            If Programmer = 8 And Programmer8.Checked = True Then Burn = True : Prog = " -A71"
            If Programmer = 9 And Programmer9.Checked = True Then Burn = True : Prog = " -A72"
            If Programmer = 10 And Programmer10.Checked = True Then Burn = True : Prog = " -A73"
            If Programmer = 11 And Programmer11.Checked = True Then Burn = True : Prog = " -A74"
            If Programmer = 12 And Programmer12.Checked = True Then Burn = True : Prog = " -A75"
            If Programmer = 13 And Programmer13.Checked = True Then Burn = True : Prog = " -A76"
            If Programmer = 14 And Programmer14.Checked = True Then Burn = True : Prog = " -A77"
            If Programmer = 15 And Programmer15.Checked = True Then Burn = True : Prog = " -A78"
            If Programmer = 16 And Programmer16.Checked = True Then Burn = True : Prog = " -A79"
            If Programmer = 17 And Programmer17.Checked = True Then Burn = True : Prog = " -A80"
            If Programmer = 18 And Programmer18.Checked = True Then Burn = True : Prog = " -A81"
            If Programmer = 19 And Programmer19.Checked = True Then Burn = True : Prog = " -A82"
            If Programmer = 20 And Programmer20.Checked = True Then Burn = True : Prog = " -A83"
            If Programmer = 21 And Programmer21.Checked = True Then Burn = True : Prog = " -A84"
            If Programmer = 22 And Programmer22.Checked = True Then Burn = True : Prog = " -A85"
            If Programmer = 23 And Programmer23.Checked = True Then Burn = True : Prog = " -A86"
            If Programmer = 24 And Programmer24.Checked = True Then Burn = True : Prog = " -A87"
            If Programmer = 25 And Programmer25.Checked = True Then Burn = True : Prog = " -A88"
            If Programmer = 26 And Programmer26.Checked = True Then Burn = True : Prog = " -A89"
            If Programmer = 27 And Programmer27.Checked = True Then Burn = True : Prog = " -A90"
            If Programmer = 28 And Programmer28.Checked = True Then Burn = True : Prog = " -A91"
            If Programmer = 29 And Programmer29.Checked = True Then Burn = True : Prog = " -A92"
            If Programmer = 30 And Programmer30.Checked = True Then Burn = True : Prog = " -A93"
            If Programmer = 31 And Programmer31.Checked = True Then Burn = True : Prog = " -A94"
            If Programmer = 32 And Programmer32.Checked = True Then Burn = True : Prog = " -A95"
            If Programmer = 33 And Programmer33.Checked = True Then Burn = True : Prog = " -A96"
            If Programmer = 34 And Programmer34.Checked = True Then Burn = True : Prog = " -A97"
            If Programmer = 35 And Programmer35.Checked = True Then Burn = True : Prog = " -A98"
            If Programmer = 36 And Programmer36.Checked = True Then Burn = True : Prog = " -A99"
            If Programmer = 37 And Programmer37.Checked = True Then Burn = True : Prog = " -A100"
            If Programmer = 38 And Programmer38.Checked = True Then Burn = True : Prog = " -A101"
            If Programmer = 39 And Programmer39.Checked = True Then Burn = True : Prog = " -A102"
            If Programmer = 40 And Programmer40.Checked = True Then Burn = True : Prog = " -A103"
            If Programmer = 41 And Programmer41.Checked = True Then Burn = True : Prog = " -A104"
            If Programmer = 42 And Programmer42.Checked = True Then Burn = True : Prog = " -A105"
            If Programmer = 43 And Programmer43.Checked = True Then Burn = True : Prog = " -A106"
            If Programmer = 44 And Programmer44.Checked = True Then Burn = True : Prog = " -A107"
            If Programmer = 45 And Programmer45.Checked = True Then Burn = True : Prog = " -A108"
            If Programmer = 46 And Programmer46.Checked = True Then Burn = True : Prog = " -A109"
            If Programmer = 47 And Programmer47.Checked = True Then Burn = True : Prog = " -A110"
            If Programmer = 48 And Programmer48.Checked = True Then Burn = True : Prog = " -A111"
            If Programmer = 49 And Programmer49.Checked = True Then Burn = True : Prog = " -A112"
            If Programmer = 50 And Programmer50.Checked = True Then Burn = True : Prog = " -A113"
            If Programmer = 51 And Programmer51.Checked = True Then Burn = True : Prog = " -A114"
            If Programmer = 52 And Programmer52.Checked = True Then Burn = True : Prog = " -A115"
            If Programmer = 53 And Programmer53.Checked = True Then Burn = True : Prog = " -A116"
            If Programmer = 54 And Programmer54.Checked = True Then Burn = True : Prog = " -A117"
            If Programmer = 55 And Programmer55.Checked = True Then Burn = True : Prog = " -A118"
            If Programmer = 56 And Programmer56.Checked = True Then Burn = True : Prog = " -A119"

            Dim AutoCloseOption As String = ""
            If AutoClose.Checked = True Then
                AutoCloseOption = " -X"
            End If

            Dim AutoProgramOption As String = ""
            If AutoProgram.Checked = True Then
                AutoProgramOption = " -P"
            End If

            If Burn = True Then
                pinfo.UseShellExecute = False
                pinfo.RedirectStandardOutput = True
                pinfo.Arguments = config + Prog + AutoProgramOption + AutoCloseOption
                pinfo.FileName = strExe
                'pinfo.WorkingDirectory = "G:\Utils"
                pinfo.WindowStyle = ProcessWindowStyle.Normal
                pinfo.CreateNoWindow = True
                p.StartInfo = pinfo
                p.Start()
            End If

        Next Programmer

        'Dim a As String = "C:\Program Files (x86)\melabs Programmer\meProg.exe"
        'Interaction.Shell(a, , True, 100000)

    End Sub
    Private Sub FirstProgrammer_ValueChanged(sender As Object, e As EventArgs) Handles FirstProgrammer.ValueChanged
        RefreshUI()
    End Sub
    Private Sub LastProgrammer_ValueChanged(sender As Object, e As EventArgs) Handles LastProgrammer.ValueChanged
        RefreshUI()
    End Sub
    Public Sub RefreshUI()
        If FirstProgrammer.Value > LastProgrammer.Value Then
            LastProgrammer.Value = FirstProgrammer.Value
        Else
            If LastProgrammer.Value < FirstProgrammer.Value Then
                FirstProgrammer.Value = LastProgrammer.Value
            End If
        End If

        Programmer1.Checked = False
        Programmer2.Checked = False
        Programmer3.Checked = False
        Programmer4.Checked = False
        Programmer5.Checked = False
        Programmer6.Checked = False
        Programmer7.Checked = False
        Programmer8.Checked = False
        Programmer9.Checked = False
        Programmer10.Checked = False
        Programmer11.Checked = False
        Programmer12.Checked = False
        Programmer13.Checked = False
        Programmer14.Checked = False
        Programmer15.Checked = False
        Programmer16.Checked = False
        Programmer17.Checked = False
        Programmer18.Checked = False
        Programmer19.Checked = False
        Programmer20.Checked = False
        Programmer21.Checked = False
        Programmer22.Checked = False
        Programmer23.Checked = False
        Programmer24.Checked = False
        Programmer25.Checked = False
        Programmer26.Checked = False
        Programmer27.Checked = False
        Programmer28.Checked = False
        Programmer29.Checked = False
        Programmer30.Checked = False
        Programmer31.Checked = False
        Programmer32.Checked = False
        Programmer33.Checked = False
        Programmer34.Checked = False
        Programmer35.Checked = False
        Programmer36.Checked = False
        Programmer37.Checked = False
        Programmer38.Checked = False
        Programmer39.Checked = False
        Programmer40.Checked = False
        Programmer41.Checked = False
        Programmer42.Checked = False
        Programmer43.Checked = False
        Programmer44.Checked = False
        Programmer45.Checked = False
        Programmer46.Checked = False
        Programmer47.Checked = False
        Programmer48.Checked = False
        Programmer49.Checked = False
        Programmer50.Checked = False
        Programmer51.Checked = False
        Programmer52.Checked = False
        Programmer53.Checked = False
        Programmer54.Checked = False
        Programmer55.Checked = False
        Programmer56.Checked = False

        For Temp As Integer = FirstProgrammer.Value To LastProgrammer.Value
            If Temp = 1 Then Programmer1.Checked = True
            If Temp = 2 Then Programmer2.Checked = True
            If Temp = 3 Then Programmer3.Checked = True
            If Temp = 4 Then Programmer4.Checked = True
            If Temp = 5 Then Programmer5.Checked = True
            If Temp = 6 Then Programmer6.Checked = True
            If Temp = 7 Then Programmer7.Checked = True
            If Temp = 8 Then Programmer8.Checked = True
            If Temp = 9 Then Programmer9.Checked = True
            If Temp = 10 Then Programmer10.Checked = True
            If Temp = 11 Then Programmer11.Checked = True
            If Temp = 12 Then Programmer12.Checked = True
            If Temp = 13 Then Programmer13.Checked = True
            If Temp = 14 Then Programmer14.Checked = True
            If Temp = 15 Then Programmer15.Checked = True
            If Temp = 16 Then Programmer16.Checked = True
            If Temp = 17 Then Programmer17.Checked = True
            If Temp = 18 Then Programmer18.Checked = True
            If Temp = 19 Then Programmer19.Checked = True
            If Temp = 20 Then Programmer20.Checked = True
            If Temp = 21 Then Programmer21.Checked = True
            If Temp = 22 Then Programmer22.Checked = True
            If Temp = 23 Then Programmer23.Checked = True
            If Temp = 24 Then Programmer24.Checked = True
            If Temp = 25 Then Programmer25.Checked = True
            If Temp = 26 Then Programmer26.Checked = True
            If Temp = 27 Then Programmer27.Checked = True
            If Temp = 28 Then Programmer28.Checked = True
            If Temp = 29 Then Programmer29.Checked = True
            If Temp = 30 Then Programmer30.Checked = True
            If Temp = 31 Then Programmer31.Checked = True
            If Temp = 32 Then Programmer32.Checked = True
            If Temp = 33 Then Programmer33.Checked = True
            If Temp = 34 Then Programmer34.Checked = True
            If Temp = 35 Then Programmer35.Checked = True
            If Temp = 36 Then Programmer36.Checked = True
            If Temp = 37 Then Programmer37.Checked = True
            If Temp = 38 Then Programmer38.Checked = True
            If Temp = 39 Then Programmer39.Checked = True
            If Temp = 40 Then Programmer40.Checked = True
            If Temp = 41 Then Programmer41.Checked = True
            If Temp = 42 Then Programmer42.Checked = True
            If Temp = 43 Then Programmer43.Checked = True
            If Temp = 44 Then Programmer44.Checked = True
            If Temp = 45 Then Programmer45.Checked = True
            If Temp = 46 Then Programmer46.Checked = True
            If Temp = 47 Then Programmer47.Checked = True
            If Temp = 48 Then Programmer48.Checked = True
            If Temp = 49 Then Programmer49.Checked = True
            If Temp = 50 Then Programmer50.Checked = True
            If Temp = 51 Then Programmer51.Checked = True
            If Temp = 52 Then Programmer52.Checked = True
            If Temp = 53 Then Programmer53.Checked = True
            If Temp = 54 Then Programmer54.Checked = True
            If Temp = 55 Then Programmer55.Checked = True
            If Temp = 56 Then Programmer56.Checked = True
        Next
    End Sub
    Private Sub R1x_Click(sender As Object, e As EventArgs) Handles R1x.Click
        RunConfigure(FirmwarePath + "R2X_12F683.hex -DPIC12F683")
    End Sub
    Private Sub R2x_Click(sender As Object, e As EventArgs) Handles R2x.Click
        RunConfigure(FirmwarePath + "R2X_12F683.hex -DPIC12F683")
    End Sub
    Private Sub ZR1x_Click(sender As Object, e As EventArgs) Handles ZR1x.Click
        RunConfigure(FirmwarePath + "ZR1x_ZR2x_2014.HEX -DPIC12F683")
    End Sub
    Private Sub ZR2x_Click(sender As Object, e As EventArgs) Handles ZR2x.Click
        RunConfigure(FirmwarePath + "ZR1x_ZR2x_2014.HEX -DPIC12F683")
    End Sub
    Private Sub R4xPRO_Click(sender As Object, e As EventArgs) Handles R4xPRO.Click
        TestApplication.Text = "R4xPRO"
        RunConfigure(FirmwarePath + "R4x_PRO.HEX -DPIC16F628A")
    End Sub
    Private Sub R8xPRO_Click(sender As Object, e As EventArgs) Handles R8xPRO.Click
        TestApplication.Text = "R8xPRO"
        RunConfigure(FirmwarePath + "R8x_PRO.HEX -DPIC16F628A")
    End Sub
    Private Sub R1xPL_Click(sender As Object, e As EventArgs) Handles R1xPL.Click
        TestApplication.Text = "R1xPL"
        RunConfigure(FirmwarePath + "ProXR_Lite124_ENH.HEX -DPIC18F14K22")
    End Sub
    Private Sub R2xPL_Click(sender As Object, e As EventArgs) Handles R2xPL.Click
        TestApplication.Text = "R2xPL"
        RunConfigure(FirmwarePath + "ProXR_Lite124_ENH.HEX -DPIC18F14K22")
    End Sub
    Private Sub R4xPL_Click(sender As Object, e As EventArgs) Handles R4xPL.Click
        TestApplication.Text = "R4xPL"
        RunConfigure(FirmwarePath + "ProXR_Lite124_ENH.HEX -DPIC18F14K22")
    End Sub
    Private Sub R8xPL_Click(sender As Object, e As EventArgs) Handles R8xPL.Click
        TestApplication.Text = "R8xPL"
        RunConfigure(FirmwarePath + "ProXR_Lite8_ENH.HEX -DPIC18F14K22")
    End Sub
    Private Sub ProXRAD8_Click(sender As Object, e As EventArgs) Handles ProXRAD8.Click
        RunConfigure(FirmwarePath + "ProXR_ENH_AD8.HEX -DPIC18F14K22")
    End Sub
    Private Sub ProXRUXP_Click(sender As Object, e As EventArgs) Handles ProXRUXP.Click
        RunConfigure(FirmwarePath + "ProXR_ENH_UXP_V3_5.HEX -DPIC18F14K22")
    End Sub
    Private Sub ProXRAD1216_Click(sender As Object, e As EventArgs) Handles ProXRAD1216.Click
        RunConfigure(FirmwarePath + "ProXR_ENH_AD1216.HEX -DPIC18F14K22")
    End Sub
    Private Sub LRR1x_Click(sender As Object, e As EventArgs) Handles LRR1x.Click
        RunConfigure(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
    End Sub
    Private Sub LRR2x_Click(sender As Object, e As EventArgs) Handles LRR2x.Click
        RunConfigure(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
    End Sub
    Private Sub LRR4x_Click(sender As Object, e As EventArgs) Handles LRR4x.Click
        RunConfigure(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
    End Sub
    Private Sub LRR4x0_Click(sender As Object, e As EventArgs) Handles LRR4x0.Click
        RunConfigure(FirmwarePath + "Reactor_V49_R4x0.HEX -DPIC16F690")
    End Sub
    Private Sub LRR8x_Click(sender As Object, e As EventArgs) Handles LRR8x.Click
        RunConfigure(FirmwarePath + "ReactorLIVE_V49.HEX -DPIC16F690")
    End Sub
    Private Sub Taralist_ENH_Click(sender As Object, e As EventArgs) Handles Taralist_ENH.Click
        RunConfigure(FirmwarePath + "ProXR_ENH_TAR_C.HEX -DPIC18F14K22")
    End Sub
    Private Sub ProXRStandardAD8_Click(sender As Object, e As EventArgs) Handles ProXRStandardAD8.Click
        CPUError()
        'RunConfigure("C:\Users\Lenovo\Documents\Firmware\ReactorLIVE_V49.HEX -DPIC16F690")
    End Sub
    Private Sub ProXRStandardUXP_Click(sender As Object, e As EventArgs) Handles ProXRStandardUXP.Click
        CPUError()
        'RunConfigure("C:\Users\Lenovo\Documents\Firmware\ReactorLIVE_V49.HEX -DPIC16F690")
    End Sub
    Private Sub BeanaVision_Click(sender As Object, e As EventArgs) Handles BeanaVision.Click
        RunConfigure(FirmwarePath + "WIOADR16x.HEX -DPIC16F877")
    End Sub
    Private Sub Fusion_Click(sender As Object, e As EventArgs) Handles Fusion.Click
        RunConfigure(FirmwarePath + "FUSION_FULL.HEX -DPIC18F46K22")
    End Sub
    Private Sub FusionS3B_Click(sender As Object, e As EventArgs) Handles FusionS3B.Click
        RunConfigure(FirmwarePath + "FUSION_FULL_S3B.HEX -DPIC18F46K22")
    End Sub
    Private Sub FusionMirW_Click(sender As Object, e As EventArgs) Handles FusionMirW.Click
        RunConfigure(FirmwarePath + "FUSION_MirW_Receiver.HEX -DPIC18F46K22")
    End Sub

    Private Sub EnterpriseSensors_Click(sender As Object, e As EventArgs) Handles EnterpriseSensors.Click
        'http://ww1.microchip.com/downloads/en/AppNotes/00002466A.pdf
        'atprogram -t jtagice3 -i jtag -d at32uc3b0512 program -f e: \file.elf
        'atprogram -t avrone -i pdi -d atxmega128a1 chiperase

    End Sub
    Private Sub Fusion_S3B_MirW_Receiver_Click(sender As Object, e As EventArgs) Handles Fusion_S3B_MirW_Receiver.Click
        RunConfigure(FirmwarePath + "FUSION_MirW_Receiver.HEX -DPIC18F46K22")
    End Sub
    Private Sub MirCC1x_S3B_Push_Click(sender As Object, e As EventArgs) Handles MirCC1x_S3B_Push.Click

    End Sub
    Private Sub MirCC2x_S3B_Push_Click(sender As Object, e As EventArgs) Handles MirCC2x_S3B_Push.Click

    End Sub
    Private Sub MirCC4x_S3B_Push_Click(sender As Object, e As EventArgs) Handles MirCC4x_S3B_Push.Click

    End Sub
    Private Sub MirCC8x_S3B_Push_Click(sender As Object, e As EventArgs) Handles MirCC8x_S3B_Push.Click

    End Sub
    Private Sub MirCC1x_Serial_Push_Click(sender As Object, e As EventArgs) Handles MirCC1x_Serial_Push.Click

    End Sub
    Private Sub MirCC2x_Serial_Push_Click(sender As Object, e As EventArgs) Handles MirCC2x_Serial_Push.Click

    End Sub
    Private Sub MirCC4x_Serial_Push_Click(sender As Object, e As EventArgs) Handles MirCC4x_Serial_Push.Click

    End Sub
    Private Sub MirCC8x_Serial_Push_Click(sender As Object, e As EventArgs) Handles MirCC8x_Serial_Push.Click

    End Sub
    Private Sub MirCC1x_USB_Push_Click(sender As Object, e As EventArgs) Handles MirCC1x_USB_Push.Click

    End Sub
    Private Sub MirCC2x_USB_Push_Click(sender As Object, e As EventArgs) Handles MirCC2x_USB_Push.Click

    End Sub
    Private Sub MirCC4x_USB_Push_Click(sender As Object, e As EventArgs) Handles MirCC4x_USB_Push.Click

    End Sub
    Private Sub MirCC8x_USB_Push_Click(sender As Object, e As EventArgs) Handles MirCC8x_USB_Push.Click

    End Sub
    Private Sub MirCC1x_WiFi_Push_Click(sender As Object, e As EventArgs) Handles MirCC1x_WiFi_Push.Click

    End Sub
    Private Sub MirCC2x_WiFi_Push_Click(sender As Object, e As EventArgs) Handles MirCC2x_WiFi_Push.Click

    End Sub
    Private Sub MirCC4x_WiFi_Push_Click(sender As Object, e As EventArgs) Handles MirCC4x_WiFi_Push.Click

    End Sub
    Private Sub MirCC8x_WiFi_Push_Click(sender As Object, e As EventArgs) Handles MirCC8x_WiFi_Push.Click

    End Sub
    Private Sub MirCC1x_Ethernet_Push_Click(sender As Object, e As EventArgs) Handles MirCC1x_Ethernet_Push.Click

    End Sub
    Private Sub MirCC2x_Ethernet_Push_Click(sender As Object, e As EventArgs) Handles MirCC2x_Ethernet_Push.Click

    End Sub
    Private Sub MirCC4x_Ethernet_Push_Click(sender As Object, e As EventArgs) Handles MirCC4x_Ethernet_Push.Click

    End Sub
    Private Sub MirCC8x_Ethernet_Push_Click(sender As Object, e As EventArgs) Handles MirCC8x_Ethernet_Push.Click

    End Sub
    Private Sub KFX_Click(sender As Object, e As EventArgs) Handles KFX.Click
        RunConfigure(FirmwarePath + "KFX_V2.HEX -DPIC18F14K22")
    End Sub

    Private Sub Industrial_Click(sender As Object, e As EventArgs) Handles Industrial.Click

    End Sub

    Private Sub GroupBox1_Enter(sender As Object, e As EventArgs) Handles GroupBox1.Enter

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        FillAdminInfo()

    End Sub

    ''' <summary>
    ''' Fill form with Admininformation loaded
    ''' </summary>
    Private Sub FillAdminInfo()
        adminInfo.Load()
        txtFirmware.Text = adminInfo.FirmwarePath
        txtProgrammer.Text = adminInfo.ProgrammerPath
        If adminInfo.ComPorts IsNot Nothing Then
            For Each item In adminInfo.ComPorts
                ExcludedUSBPorts.Items.Add(item.PortName, item.Selected)
            Next
        End If
        If adminInfo.AtmelICE IsNot Nothing Then
            For Each item In adminInfo.AtmelICE
                AtmelICESerialNumbers.Items.Add(item)
            Next
        End If
    End Sub
    Private mSerialPortInfos() As NCDEnterprise.SerialDeviceInfo

    ''' <summary>
    ''' Get com ports in strings, exclude the one selected
    ''' </summary>
    ''' <returns></returns>
    Private Function GetUsableComPorts() As String()
        Dim ports As New ArrayList
        Dim portsString() As String
        mSerialPortInfos = NCDEnterprise.ListPorts.EnumPorts()
        If Not (mSerialPortInfos Is Nothing) Then
            For Each p In mSerialPortInfos
                ports.Add(p.PortName)
            Next
            portsString = ports.ToArray(GetType(String))
            portsString = adminInfo.GetUnselectedPorts(portsString)
        End If
        Return portsString
    End Function

    Private Sub ScanPorts_Click(sender As Object, e As EventArgs) Handles ScanPorts.Click

        'mSerialPortInfos = NCDEnterprise.ListPorts.EnumPorts()
        'USBTestingPorts.Items.Clear()
        'If Not (mSerialPortInfos Is Nothing) Then
        '    For i As Integer = 0 To mSerialPortInfos.Length - 1
        '        USBTestingPorts.Items.Add(mSerialPortInfos(i).PortName)
        '    Next
        '    If USBTestingPorts.Items.Count > 0 And PortName = String.Empty Then
        '        USBTestingPorts.SelectedIndex = 0
        '    Else
        '        USBTestingPorts.Text = PortName
        '    End If
        'End If
        Dim ports() As String = GetUsableComPorts()
        If Not (ports Is Nothing) Then
            For Each p In ports
                USBTestingPorts.Items.Add(p)
            Next
            If USBTestingPorts.Items.Count > 0 And PortName = String.Empty Then
                USBTestingPorts.SelectedIndex = 0
            Else
                USBTestingPorts.Text = PortName
            End If
        End If

    End Sub
    Public Property PortName() As String
        Get
            Return USBTestingPorts.Text
        End Get
        Set(ByVal value As String)
            USBTestingPorts.Text = value
        End Set
    End Property


    ''' <summary>
    ''' Update serial ports scaned, will keep selected ports's status if they are exist
    ''' </summary>
    'Public Sub UpdateSerialPorts(portsnew() As PortInfo, portsOld())
    '    If ports Is Nothing Then
    '        Exit Sub
    '    End If
    '    If ComPorts Is Nothing Then
    '        ComPorts = ports
    '        Exit Sub
    '    End If
    '    For Each newPort As PortInfo In ports
    '        For Each oldPort As PortInfo In ComPorts
    '            If (newPort.PortName = oldPort.PortName) Then
    '                newPort.Selected = oldPort.Selected
    '            End If
    '        Next
    '    Next
    '    ' update ports
    '    ComPorts = ports
    'End Sub

    ' Private mSerialPortInfos() As NCDEnterprise.SerialDeviceInfo
    Private Sub ExcludeScanPorts_Click(sender As Object, e As EventArgs) Handles ExcludeScanPorts.Click

        mSerialPortInfos = NCDEnterprise.ListPorts.EnumPorts()
        Dim portsArr As New ArrayList
        ' keep the current selected
        Dim oldportsArr As New ArrayList
        For Each item In ExcludedUSBPorts.CheckedItems
            Dim port As New AdminInformation.PortInfo
            port.PortName = item.ToString
            port.Selected = True
            oldportsArr.Add(port)
        Next

        USBTestingPorts.Items.Clear()
        ExcludedUSBPorts.Items.Clear()
        If Not (mSerialPortInfos Is Nothing) Then
            For Each p In mSerialPortInfos
                Dim portInfo As New AdminInformation.PortInfo
                portInfo.PortName = p.PortName
                portsArr.Add(portInfo)
            Next
            For Each p In portsArr
                For Each pold In oldportsArr
                    If p.PortName = pold.PortName Then
                        p.selected = True
                    End If
                Next
            Next
            'Dim portsInfo() As AdminInformation.PortInfo = portsArr.ToArray(GetType(AdminInformation.PortInfo))
            ''adminInfo.UpdateSerialPorts(portsInfo)
            'If adminInfo.ComPorts Is Nothing Then
            '    Exit Sub
            'End If
            For Each p In portsArr
                Dim id As Integer = ExcludedUSBPorts.Items.Add(p.PortName, p.Selected)
            Next

            If ExcludedUSBPorts.Items.Count > 0 And PortName2 = String.Empty Then
                ExcludedUSBPorts.SelectedIndex = 0
            Else
                ExcludedUSBPorts.Text = PortName2
            End If
        End If
    End Sub
    Public Property PortName2() As String
        Get
            Return ExcludedUSBPorts.Text
        End Get
        Set(ByVal value As String)
            ExcludedUSBPorts.Text = value
        End Set
    End Property

    Private Sub SelectAll_Click(sender As Object, e As EventArgs) Handles SelectAll.Click
        For i = 0 To USBTestingPorts.Items.Count - 1
            USBTestingPorts.SetItemChecked(i, True)

        Next
    End Sub

    Private Sub Setup_Click(sender As Object, e As EventArgs) Handles Setup.Click

    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        'adminInfo.FirmwarePath = "c:\tt"
        'adminInfo.ProgrammerPath = "d:\tt"
        Dim portsArr As New ArrayList
        For i = 1 To ExcludedUSBPorts.Items.Count
            Dim port As New AdminInformation.PortInfo
            port.PortName = ExcludedUSBPorts.Items.Item(i - 1).ToString
            port.Selected = ExcludedUSBPorts.GetItemChecked(i - 1)
            portsArr.Add(port)
        Next
        adminInfo.ComPorts = portsArr.ToArray(GetType(AdminInformation.PortInfo))
        Dim AtmelIECArr As New ArrayList

        For Each item In AtmelICESerialNumbers.Items
            AtmelIECArr.Add(item.ToString)
        Next
        adminInfo.AtmelICE = AtmelIECArr.ToArray(GetType(String))

        adminInfo.FirmwarePath = txtFirmware.Text
        adminInfo.ProgrammerPath = txtProgrammer.Text
        adminInfo.Save()

        FirmwarePath = adminInfo.FirmwarePath
        ' update programmer path, if needed

    End Sub

    Private Sub ExcludedUSBPorts_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ExcludedUSBPorts.SelectedIndexChanged

    End Sub

    Private Sub btnAddAtmel_Click(sender As Object, e As EventArgs) Handles btnAddAtmel.Click
        Dim frm As New frmAddAtmel
        If frm.ShowDialog = DialogResult.OK Then
            AtmelICESerialNumbers.Items.Add(frm.txtID.Text)
        End If

    End Sub

    Private Sub SetFirmwarePath_Click(sender As Object, e As EventArgs) Handles SetFirmwarePath.Click
        FolderBrowserDialog1.SelectedPath = txtFirmware.Text
        If FolderBrowserDialog1.ShowDialog() = DialogResult.OK Then
            txtFirmware.Text = FolderBrowserDialog1.SelectedPath
        End If
    End Sub

    Private Sub SetProgrammerPath_Click(sender As Object, e As EventArgs) Handles SetProgrammerPath.Click
        OpenFileDialog1.FileName = txtProgrammer.Text
        If OpenFileDialog1.ShowDialog = DialogResult.OK Then
            txtProgrammer.Text = OpenFileDialog1.FileName
        End If
    End Sub

    Private Sub chkDeleteAtmel_Click(sender As Object, e As EventArgs) Handles chkDeleteAtmel.Click
        If AtmelICESerialNumbers.SelectedItem Is Nothing Then
        Else
            AtmelICESerialNumbers.Items.Remove(AtmelICESerialNumbers.SelectedItem)

        End If
    End Sub

    Private Sub TestSelectedDevices_Click(sender As Object, e As EventArgs) Handles TestSelectedDevices.Click

    End Sub

    Private Sub SelectNone_Click(sender As Object, e As EventArgs) Handles SelectNone.Click
        For i = 0 To USBTestingPorts.Items.Count - 1
            USBTestingPorts.SetItemChecked(i, False)

        Next
    End Sub
End Class