﻿
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports System.Diagnostics
' ElzeKool.net contains the HTTPServer classes

Imports System.Windows.Forms



Public Class frmSelectConnection

    Public adminInfo As New AdminInformation

    Public Shared SparkCoreChecked As Boolean = False
    Public Shared WirelessSensorsChecked As Boolean = True

    Private ncdObj As UDPNetwork = Nothing

    Private wiflyObj As WiflyDiscovery = Nothing
    Private mDeviceList As New ArrayList()

    Private mDestHigh As Int32

    Private mDestLow As Int32

    Public Property DestHigh() As Long
        Get
            UpdateAddressValue()
            Return mDestHigh
        End Get
        Set(value As Long)
            mDestHigh = value
            UpdateAddress()
        End Set
    End Property

    Public Property DestLow() As Long
        Get
            UpdateAddressValue()
            Return mDestLow
        End Get
        Set(value As Long)
            mDestLow = value
            UpdateAddress()
        End Set
    End Property

    ''' <summary>
    ''' Update Address from value to GUI
    ''' </summary>
    Private Sub UpdateAddress()
        AD1.Value = (mDestHigh And &HFF000000) / &H1000000
        AD2.Value = (mDestHigh And &HFF0000) / &H10000
        AD3.Value = (mDestHigh And &HFF00) / &H100
        AD4.Value = mDestHigh And &HFF

        AD5.Value = (mDestLow And &HFF000000) / &H1000000
        AD6.Value = (mDestLow And &HFF0000) / &H10000
        AD7.Value = (mDestLow And &HFF00) / &H100
        AD8.Value = mDestLow And &HFF

    End Sub

    ''' <summary>
    ''' Update address value from GUI
    ''' </summary>
    Private Sub UpdateAddressValue()
        mDestHigh = AD1.Value
        mDestHigh = mDestHigh * &H100 + AD2.Value
        mDestHigh = mDestHigh * &H100 + AD3.Value
        mDestHigh = mDestHigh * &H100 + AD4.Value

        mDestLow = AD5.Value
        mDestLow = mDestLow * &H100 + AD6.Value
        mDestLow = mDestLow * &H100 + AD7.Value
        mDestLow = mDestLow * &H100 + AD8.Value


    End Sub

    Public Property WirelessRemote() As Boolean
        Get
            Return UseWireless.Checked
        End Get
        Set(value As Boolean)
            UseWireless.Checked = value
        End Set

    End Property



    Private mSerialPortInfos() As NCDEnterprise.SerialDeviceInfo


    Public Property PortName() As String
        Get
            Return cmbPortName.Text
        End Get
        Set(ByVal value As String)
            cmbPortName.Text = value
        End Set
    End Property

    Public Property Baudrate() As Integer
        Get
            Return System.Convert.ToInt32(cmbBaudrate.Text)
        End Get
        Set(ByVal value As Integer)
            cmbBaudrate.Text = value.ToString
        End Set
    End Property

    Public Property HighSpeedNetworkProfile() As Boolean
        Get
            Return chkHighSpeedNetworkProfile.Checked
        End Get
        Set(value As Boolean)
            chkHighSpeedNetworkProfile.Checked = value
        End Set
    End Property

    Public Property IPAddress() As String
        Get
            Return txtIP.Text
        End Get
        Set(ByVal value As String)
            txtIP.Text = value
        End Set
    End Property

    Public Property PortNumber() As Integer
        Get
            Return System.Convert.ToInt32(txtNetworkPort.Text)
        End Get
        Set(value As Integer)
            txtNetworkPort.Text = value.ToString
        End Set
    End Property



    Public Property UsingSerialPort() As Boolean
        Get
            Return rdComPort.Checked
        End Get
        Set(ByVal value As Boolean)
            rdComPort.Checked = value
            rdNetwork.Checked = Not value
            rdProXRServer.Checked = False
        End Set
    End Property


    Private Sub OnGetIpAndMac(ByVal info As ProXRDeviceInfo)
        If Not Created Then
            Return
        End If
        If Me.InvokeRequired Then
            Dim [call] As New UpdateMessageHandler(AddressOf OnGetIpAndMac)
            BeginInvoke([call], info)
        Else
            Dim bFound As Boolean = False
            For i As Integer = 0 To mDeviceList.Count - 1
                Dim deviceInfo As ProXRDeviceInfo = DirectCast(mDeviceList(i), ProXRDeviceInfo)
                If deviceInfo.IsSameDevice(info) Then
                    mDeviceList(i) = info
                    UpdateListView(i, info)
                    bFound = True
                    Exit For
                End If
            Next
            If Not bFound Then
                mDeviceList.Add(info)
                AppendToListView(info)

            End If
        End If

    End Sub


    ''' <summary>
    ''' Add new device to list
    ''' </summary>
    ''' <param name="info"></param>
    Private Sub AppendToListView(ByVal info As ProXRDeviceInfo)
        Dim item As New ListViewItem(info.GetDescripation())
        listViewDevices.Items.Add(item)
        rdProXRServer.Enabled = True
        listViewDevices.Enabled = True
    End Sub

    ''' <summary>
    ''' Update list view 
    ''' </summary>
    ''' <param name="id"></param>
    ''' <param name="info"></param>
    Private Sub UpdateListView(ByVal id As Integer, ByVal info As ProXRDeviceInfo)
        Dim selected As Boolean = listViewDevices.Items(id).Selected
        listViewDevices.Items(id) = New ListViewItem(info.GetDescripation())
        listViewDevices.Items(id).Selected = selected
    End Sub


    Private Sub listViewDevices_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles listViewDevices.DoubleClick
        OpenWebPage()
    End Sub

    ''' <summary>
    ''' Open web page for ethernet and winet device
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub OpenWebPage()
        Dim webAddressUrl As String
        If (listViewDevices.SelectedItems.Count = 1) Then
            If (listViewDevices.SelectedItems(0).Text.Contains(":")) Then
                webAddressUrl = "http://" & listViewDevices.SelectedItems(0).Text.Split(New Char() {":"c})(0)
            Else
                webAddressUrl = "http://" & listViewDevices.SelectedItems(0).Text
            End If

            Try
                System.Diagnostics.Process.Start(webAddressUrl)
            Catch
            End Try

        End If
    End Sub

    Private Sub FillComPortList()
        mSerialPortInfos = NCDEnterprise.ListPorts.EnumPorts()
        cmbPortName.Items.Clear()
        If Not (mSerialPortInfos Is Nothing) Then
            For i As Integer = 0 To mSerialPortInfos.Length - 1
                cmbPortName.Items.Add(mSerialPortInfos(i).PortName)
            Next
            If cmbPortName.Items.Count > 0 And PortName = String.Empty Then
                cmbPortName.SelectedIndex = 0
            Else
                cmbPortName.Text = PortName
            End If
        End If
    End Sub

    Private Sub frmSelectConnection_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load



        If GetQuickLaunchSetting() = True Then
            Debug.Print("Quick Launch is Active")
            ' NcdComponent1.ClosePort()
            Dim frm As frmNcdAdmin2  ' define a form variable
            frm = New frmNcdAdmin2   ' create the new form
            ' frm.NCDComponent1 = ncdObj   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
            'NcdComponent1.OpenPort()
        Else
            Debug.Print("Quick Launch is Not Active")
        End If

        FillComPortList()

        ncdObj = New UDPNetwork()
        ncdObj.OnGetIpAndMac = AddressOf OnGetIpAndMac
        ncdObj.Start()

        wiflyObj = New WiflyDiscovery()
        wiflyObj.OnGetIpAndMac = AddressOf OnGetIpAndMac
        wiflyObj.Start()

    End Sub
    Private Function GetQuickLaunchSetting() As Boolean

        adminInfo.Load()
        ' txtFirmware.Text = adminInfo.FirmwarePath
        ' txtProgrammer.Text = adminInfo.ProgrammerPath
        'If adminInfo.ComPorts IsNot Nothing Then
        ' For Each item In adminInfo.ComPorts
        'ExcludedUSBPorts.Items.Add(item.PortName, item.Selected)
        'Next
        'End If
        'If adminInfo.AtmelICE IsNot Nothing Then
        ' For Each item In adminInfo.AtmelICE
        'AtmelICESerialNumbers.Items.Add(item)
        'Next
        'End If

        ' XBCOM1.Value = adminInfo.ComPort1
        ' XBCOM2.Value = adminInfo.ComPort2
        ' XBCOM3.Value = adminInfo.ComPort3
        ' XBCOM4.Value = adminInfo.ComPort4
        ' XBCOM5.Value = adminInfo.ComPort5
        ' XBCOM6.Value = adminInfo.ComPort6
        ' XBCOM7.Value = adminInfo.ComPort7
        ' XBCOM8.Value = adminInfo.ComPort8
        ' XBCOM9.Value = adminInfo.ComPort9
        ' XBCOM10.Value = adminInfo.ComPort10
        ' XBCOM11.Value = adminInfo.ComPort11
        ' XBCOM12.Value = adminInfo.ComPort12
        ' XBCOM13.Value = adminInfo.ComPort13
        ' XBCOM14.Value = adminInfo.ComPort14
        ' XBCOM15.Value = adminInfo.ComPort15
        ' XBCOM16.Value = adminInfo.ComPort16
        ' XBCOM17.Value = adminInfo.ComPort17
        ' XBCOM18.Value = adminInfo.ComPort18
        ' XBCOM19.Value = adminInfo.ComPort19
        ' XBCOM20.Value = adminInfo.ComPort20
        ' XBCOM21.Value = adminInfo.ComPort21
        ' XBCOM22.Value = adminInfo.ComPort22
        ' XBCOM23.Value = adminInfo.ComPort23
        ' XBCOM24.Value = adminInfo.ComPort24
        ' XBCOM25.Value = adminInfo.ComPort25
        ' XBCOM26.Value = adminInfo.ComPort26
        ' XBCOM27.Value = adminInfo.ComPort27
        ' XBCOM28.Value = adminInfo.ComPort28
        ' XBCOM29.Value = adminInfo.ComPort29
        ' XBCOM30.Value = adminInfo.ComPort30
        ' XBCOM31.Value = adminInfo.ComPort31
        ' XBCOM32.Value = adminInfo.ComPort32

        ' Programmer1.Checked = adminInfo.Prog1
        ' Programmer2.Checked = adminInfo.Prog2
        ' Programmer3.Checked = adminInfo.Prog3
        ' Programmer4.Checked = adminInfo.Prog4
        ' Programmer5.Checked = adminInfo.Prog5
        ' Programmer6.Checked = adminInfo.Prog6
        ' Programmer7.Checked = adminInfo.Prog7
        ' Programmer8.Checked = adminInfo.Prog8
        ' Programmer9.Checked = adminInfo.Prog9
        ' Programmer10.Checked = adminInfo.Prog10
        ' Programmer11.Checked = adminInfo.Prog11
        ' Programmer12.Checked = adminInfo.Prog12
        ' Programmer13.Checked = adminInfo.Prog13
        ' Programmer14.Checked = adminInfo.Prog14
        ' Programmer15.Checked = adminInfo.Prog15
        ' Programmer16.Checked = adminInfo.Prog16
        ' Programmer17.Checked = adminInfo.Prog17
        ' Programmer18.Checked = adminInfo.Prog18
        ' Programmer19.Checked = adminInfo.Prog19
        ' Programmer20.Checked = adminInfo.Prog20
        ' Programmer21.Checked = adminInfo.Prog21
        ' Programmer22.Checked = adminInfo.Prog22
        ' Programmer23.Checked = adminInfo.Prog23
        ' Programmer24.Checked = adminInfo.Prog24
        ' Programmer25.Checked = adminInfo.Prog25
        ' Programmer26.Checked = adminInfo.Prog26
        ' Programmer27.Checked = adminInfo.Prog27
        ' Programmer28.Checked = adminInfo.Prog28
        ' Programmer29.Checked = adminInfo.Prog29
        ' Programmer30.Checked = adminInfo.Prog30
        ' Programmer31.Checked = adminInfo.Prog31
        ' Programmer32.Checked = adminInfo.Prog32
        '
        ' FirstProgrammer.Value = adminInfo.FirstProg
        ' LastProgrammer.Value = adminInfo.LastProg
        ' AutoProgram.Checked = adminInfo.AutoProgram
        ' AutoClose.Checked = adminInfo.AutoClose
        GetQuickLaunchSetting = adminInfo.QuickLaunch

    End Function


    Private Sub frmSelectConnection_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        ncdObj.Stop()
        wiflyObj.Stop()
    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click
        If rdProXRServer.Checked And listViewDevices.SelectedIndices.Count = 0 Then
            MsgBox("Please select ProXR Server device from list")
            DialogResult = Windows.Forms.DialogResult.None
        End If
        If (rdProXRServer.Checked And listViewDevices.SelectedIndices.Count = 1) Then
            If (listViewDevices.SelectedItems(0).Text.Contains(":")) Then
                IPAddress = listViewDevices.SelectedItems(0).Text.Split(New Char() {":"c})(0)
                PortNumber = Integer.Parse(listViewDevices.SelectedItems(0).Text.Split(New Char() {":"c})(1))
            ElseIf (listViewDevices.SelectedItems(0).SubItems(2).Text.Trim = "WiNet") Then
                OpenWebPage()
                DialogResult = Windows.Forms.DialogResult.None
            Else
                IPAddress = listViewDevices.SelectedItems(0).Text
                PortNumber = 2101
            End If
            UsingSerialPort = False
        End If
    End Sub

    Private Sub cmbPortName_DrawItem(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles cmbPortName.DrawItem
        e.DrawBackground()
        e.Graphics.DrawString(mSerialPortInfos(e.Index).FriendName, e.Font, System.Drawing.Brushes.Black, e.Bounds)
        e.DrawFocusRectangle()
    End Sub

    Private Sub listViewDevices_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles listViewDevices.Click
        rdProXRServer.Checked = True
    End Sub

    Private Sub txtIP_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtIP.Enter, txtNetworkPort.Enter
        rdNetwork.Checked = True
    End Sub

    Private Sub cmbPortName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbPortName.Enter, cmbBaudrate.Enter
        rdComPort.Checked = True
    End Sub
    Public Sub LinkTo(ByVal Address As String)
        Try
            System.Diagnostics.Process.Start(Address) ' start browser for that link
        Catch ex As Exception
        End Try
    End Sub
    Private Sub DefaultSettings_Click(sender As Object, e As EventArgs) Handles DefaultSettings.Click
        AD1.Value = 0
        AD2.Value = 19
        AD3.Value = 162
        AD4.Value = 0
        AD5.Value = 64
        AD6.Value = 206
        AD7.Value = 45
        AD8.Value = 49
    End Sub

    Private Sub UseWireless_CheckedChanged(sender As Object, e As EventArgs) Handles UseWireless.CheckedChanged
        If UseWireless.Checked = True Then
            DestinationGroup.Visible = True
        Else
            DestinationGroup.Visible = False
        End If
    End Sub

    Private Sub Discover_Click(sender As Object, e As EventArgs) Handles Discover.Click
        Dim frm As frmDiscoverNode
        frm = New frmDiscoverNode
        If frm.ShowDialog() = DialogResult.OK Then

        End If
    End Sub

    Private Sub btnNCD_Click(sender As Object, e As EventArgs)

    End Sub

    Private Sub btnNCD_Click_1(sender As Object, e As EventArgs)
        Dim frm As frmNcdAdmin  ' define a form variable
        frm = New frmNcdAdmin   ' create the new form
        ' frm.NCDComponent1 = ncdObj   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()
    End Sub
End Class

Public Class ProXRDeviceInfo
    Public Mac As String
    Public IP As String
    Public Port As Integer = 2101
    Public DeviceInfo As String
    Public FirmwareVersion As String = "1.0"


    Public Shared Function ValidMacAddress(ByVal mac As String) As Boolean
        Return True
    End Function

    Public Function GetDescripation() As String()
        Return New String() {IP, Mac, DeviceInfo, FirmwareVersion}
    End Function

    Public Function IsSameDevice(ByVal info As ProXRDeviceInfo) As Boolean
        Return (Mac = info.Mac)

    End Function

    ''' <summary>
    ''' Init the device information object with data come from network
    ''' </summary>
    ''' <param name="data"></param>
    ''' <returns></returns>
    Public Function Parse(ByVal data As Byte()) As Boolean
        Dim bRtn As Boolean = False
        'data are seperated by ","
        ' Data format
        ' IP,LocalMac,RemoteMac,Server1, Server2, Server3, Server4, Port1, Port2, Port3, Port4, FirmwareVersion, ---
        Dim str As String = Encoding.UTF8.GetString(data, 0, data.Length)
        Dim strs As String() = str.Split(New Char() {","c})

        If strs.Length = 5 Then     ' XPort Por module
            Try
                IP = strs(0)
                Port = Integer.Parse(strs(2))
                Mac = strs(1)
                DeviceInfo = strs(3)
                FirmwareVersion = strs(4)

                'If strs(4) = "---" Then
                '    ' last part has to be "---"
                '    bRtn = True
                'End If
            Catch
                bRtn = False
            End Try
        ElseIf strs.Length = 6 Then     ' beagle bone
            Try
                IP = strs(0)
                Port = Integer.Parse(strs(2))
                Mac = strs(1)
                DeviceInfo = strs(3)
                FirmwareVersion = strs(4)

                'If strs(4) = "---" Then
                '    ' last part has to be "---"
                '    bRtn = True
                'End If
            Catch
                bRtn = False
            End Try

        Else                        ' webi or other module
            Try
                IP = strs(0)
                If (strs(0).Contains(":")) Then
                    Port = Integer.Parse(strs(0).Split(New Char() {":"c})(1))
                End If
                Mac = strs(1)
                DeviceInfo = strs(2)
                FirmwareVersion = strs(3)

                If strs(4) = "---" Then
                    ' last part has to be "---"
                    bRtn = True
                End If
            Catch
                bRtn = False
            End Try

        End If
        Return bRtn
    End Function

    Public Overloads Function ToString() As String
        Dim str As String = IP & "," & Mac & "," & DeviceInfo & "," & FirmwareVersion
        Return str
    End Function
End Class

Public Delegate Sub UpdateMessageHandler(ByVal mac As ProXRDeviceInfo)

''' <summary>
''' Support NCD Network Component
''' 
''' </summary>
Public Class UDPNetwork
    Public OnGetIpAndMac As UpdateMessageHandler

    Private mThread As Thread = Nothing

    ''' <summary>
    ''' Socket Listening for connections
    ''' </summary>
    Private ListenSocket As Socket = Nothing

    Public Function IsStart() As Boolean
        Return (mThread IsNot Nothing)
    End Function

    ''' <summary>
    ''' Start NCD Network Component
    ''' </summary>
    Public Function Start() As Boolean
        mThread = New Thread(New ThreadStart(AddressOf NCDNetworkThread))
        mThread.Start()
        'If (IO.File.Exists("FindConnectMe.exe")) Then
        '    Dim p As Process = New Process
        '    Dim ps As ProcessStartInfo = New ProcessStartInfo
        '    ps.FileName = "FindConnectMe.exe"
        '    ps.WindowStyle = ProcessWindowStyle.Hidden
        '    ps.CreateNoWindow = True
        '    p.StartInfo = ps
        '    p.Start()
        'End If
        Return True
    End Function

    ''' <summary>
    ''' Stop NCD Network
    ''' </summary>
    Public Function [Stop]() As Boolean
        Try

            If mThread IsNot Nothing Then
                mThread.Abort()
            End If

        Catch ex As Exception
        Finally
            mThread = Nothing
            ListenSocket.Close()
        End Try
        Return True

    End Function


    Private Sub NCDNetworkThread()
        Try
            ListenSocket = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
            Dim port As Integer = 13000
            Dim localEndPoint As New IPEndPoint(IPAddress.Any, port)
            ListenSocket.Bind(localEndPoint)
            StartCommunication(ListenSocket)
        Catch ex As System.Net.Sockets.SocketException
            ListenSocket.Close()
            MessageBox.Show(ex.Message)
            Application.[Exit]()
        End Try
    End Sub


    Private Sub StartCommunication(ByRef AcceptSocket As Socket)
        Try
            Dim buffer As Byte() = New Byte(1023) {}
            While True


                Thread.Sleep(2000)

                Dim available As Integer = AcceptSocket.Available

                Dim timeoutAt As DateTime = DateTime.Now.AddSeconds(15)
                Dim _Available As Int32 = AcceptSocket.Available
                While _Available = 0 AndAlso DateTime.Now < timeoutAt
                    Try
                        _Available = AcceptSocket.Available
                    Catch
                        Exit Try
                    End Try

                    System.Threading.Thread.Sleep(100)
                End While
                If _Available > 0 Then
                    Dim n As Integer = 0
                    While AcceptSocket.Poll(500, SelectMode.SelectRead)
                        Dim localEndPoint As EndPoint = New IPEndPoint(IPAddress.Any, 13000)

                        n = AcceptSocket.ReceiveFrom(buffer, localEndPoint)
                        Dim data As Byte() = New Byte(n - 1) {}
                        Array.Copy(buffer, data, n)
                        If OnGetIpAndMac IsNot Nothing Then
                            Dim info As New ProXRDeviceInfo()
                            info.Parse(data)
                            OnGetIpAndMac(info)
                            Debug.WriteLine(info.IP)
                        End If
                    End While
                End If

            End While

        Catch
        End Try

    End Sub





End Class

Public Class WiflyDiscovery
    Public OnGetIpAndMac As UpdateMessageHandler

    Private mThread As Thread = Nothing

    ' thread object for wifly found
    Private mWiflyThread As Thread = Nothing


    ''' <summary>
    ''' Socket Listening for connections
    ''' </summary>
    Private ListenSocket As Socket = Nothing


    Public Sub New()
    End Sub

    Public Function IsStart() As Boolean
        Return (mThread IsNot Nothing)
    End Function

    ''' <summary>
    ''' Start NCD Network Component
    ''' </summary>
    Public Function Start() As Boolean
        mWiflyThread = New Thread(New ThreadStart(AddressOf WiflyFoundThread))
        mWiflyThread.Start()
        'If (IO.File.Exists("FindConnectMe.exe")) Then
        '    Dim p As Process = New Process
        '    Dim ps As ProcessStartInfo = New ProcessStartInfo
        '    ps.FileName = "FindConnectMe.exe"
        '    ps.WindowStyle = ProcessWindowStyle.Hidden
        '    ps.CreateNoWindow = True
        '    p.StartInfo = ps
        '    p.Start()
        'End If
        Return True
    End Function

    ''' <summary>
    ''' Stop NCD Network
    ''' </summary>
    Public Function [Stop]() As Boolean
        Try

            If mThread IsNot Nothing Then
                mThread.Abort()
            End If

            If mWiflyThread IsNot Nothing Then
                mWiflyThread.Abort()
            End If
        Catch ex As Exception
        Finally
            mThread = Nothing
            ListenSocket.Close()
        End Try
        Return True

    End Function

    ''' <summary>
    ''' Thread for found wifly module
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub WiflyFoundThread()
        Try
            ListenSocket = New Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp)
            Dim port As Integer = 55555
            Dim localEndPoint As New IPEndPoint(IPAddress.Any, port)
            ListenSocket.Bind(localEndPoint)
            Dim buffer As Byte() = New Byte(1024) {}
            While True


                Thread.Sleep(100)


                Dim n As Integer = 0
                'While (n < 120)
                n += ListenSocket.ReceiveFrom(buffer, localEndPoint)
                'End While
                If (n = 120) Then
                    'n = ListenSocket.ReceiveFrom(buffer, localEndPoint)
                    If OnGetIpAndMac IsNot Nothing Then
                        Dim info As New ProXRDeviceInfo()
                        info.IP = localEndPoint.Address.ToString
                        Dim verBuf(26) As Byte
                        Array.Copy(buffer, 32, verBuf, 0, 26)
                        Dim ver As String = Encoding.UTF7.GetString(verBuf)
                        Dim p As Integer = buffer(8)
                        info.Port = p * 256 + buffer(9)

                        Dim deviceIdBuf(32) As Byte
                        Array.Copy(buffer, 60, deviceIdBuf, 0, 32)

                        info.DeviceInfo = Encoding.UTF7.GetString(deviceIdBuf)
                        info.Mac = String.Format("{0:X2}{1:X2}{2:X2}{3:X2}{4:X2}{5:X2}", buffer(110), buffer(111), buffer(112), buffer(113), buffer(114), buffer(115))
                        info.FirmwareVersion = ver
                        OnGetIpAndMac(info)
                        Debug.WriteLine(info.IP)
                    End If

                End If


            End While
        Catch ex As System.Net.Sockets.SocketException
            ListenSocket.Close()
            MessageBox.Show(ex.Message)
            Application.[Exit]()
        End Try
    End Sub



    Private Sub StartCommunication(ByRef AcceptSocket As Socket)
        Try
            Dim buffer As Byte() = New Byte(1023) {}
            While True


                Thread.Sleep(2000)

                Dim available As Integer = AcceptSocket.Available

                Dim timeoutAt As DateTime = DateTime.Now.AddSeconds(15)
                Dim _Available As Int32 = AcceptSocket.Available
                While _Available = 0 AndAlso DateTime.Now < timeoutAt
                    Try
                        _Available = AcceptSocket.Available
                    Catch
                        Exit Try
                    End Try

                    System.Threading.Thread.Sleep(100)
                End While
                If _Available > 0 Then
                    Dim n As Integer = 0
                    While AcceptSocket.Poll(500, SelectMode.SelectRead)
                        Dim localEndPoint As EndPoint = New IPEndPoint(IPAddress.Any, 13000)

                        n = AcceptSocket.ReceiveFrom(buffer, localEndPoint)
                        Dim data As Byte() = New Byte(n - 1) {}
                        Array.Copy(buffer, data, n)
                        If OnGetIpAndMac IsNot Nothing Then
                            Dim info As New ProXRDeviceInfo()
                            info.Parse(data)
                            OnGetIpAndMac(info)
                            Debug.WriteLine(info.IP)
                        End If
                    End While
                End If

            End While

        Catch
        End Try

    End Sub
End Class